// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

/*
	Added code starts here.
*/

// Parse out the score and display it.
function finishedCurling(finishedCmd)
{
	var gamerscore;
	var scoreText = document.getElementById("scoreText");
	
	// Only continue if curl exited without any problems.
	if (finishedCmd.status == 0)
	{
		gamerscore = parseScoreFromHTML(finishedCmd.outputString);
		scoreText.innerHTML = gamerscore;
	}
	
	// Turn off the loading icon.
	toggleLoadingIcon(false);
}

// Retrieve the gamertag preference and check it for validity.
function getGamertag()
{
	var gamertag = widget.preferenceForKey(widget.identifier + "-gamertag");
	
	// Use my personal tag as the default.
	if (gamertag == undefined || gamertag == "")
	{
		gamertag = "uberpuppy";
	}
	
	return gamertag;
}

// Pulls the score out of the html and formats it properly.
function parseScoreFromHTML(html)
{
	var score = 0;
	var index = 0;
	var openSpanStart = 0;
	var closeSpanStart = 0;
	var openSpan = "<span class=\"XbcFRAR\">";
	var closeSpan = "</span>";
	var extractedText = "";
	var keepSearching = true;
	
	while (keepSearching)
	{
		// Get the location of an instance of the opening tag.
		openSpanStart = html.indexOf(openSpan, index);
		if (openSpanStart == -1)
		{
			keepSearching = false;
		}
		else
		{
			// Get the location of an instance of the closing tag.
			closeSpanStart = html.indexOf(closeSpan, openSpanStart + 1);
			if (closeSpanStart == -1)
			{
				keepSearching = false;
			}
			else
			{
				// Extract the text between the opening and closing tags.
				extractedText = html.substring(openSpanStart + openSpan.length, closeSpanStart);
				
				// If it's a number, it's the score.
				if (!isNaN(extractedText))
				{
					score = extractedText;
				}
			}
		}
		
		// Make sure we don't iterate over the same tags that were just processed.
		index = openSpanStart + 1;
	}
	
	// Add commas to the score.
	var temp = "";
	for (var x = 0; x < Math.floor(score.length / 3); x++)
	{
		temp = "," + score.substring(score.length - 3) + temp;
		score = score.substring(0, score.length - 3);
	}
	
	// Append and make sure the number doesn't start with a comma (remainder was zero).
	score = score + temp;
	if (score.substring(0, 1) == ",")
	{
		score = score.substring(1);
	}
	
	return score;
}

// Core functionality for this widget.
// Fetch and display an individual gamerscore.
function refreshData()
{
	var gamertag = getGamertag();

	// Populate the gamertagTextfield.
	var gamertagTextfield = document.getElementById("gamertagTextfield");
	gamertagTextfield.value = gamertag;

	// Construct the curl command.
	var gcURL = "http://gamercard.xbox.com/" + getGamertag() + ".card";
	var gcURLEncoded = encodeURI(gcURL);
	var cmd = "/usr/bin/curl --connect-timeout 30 " + gcURLEncoded;
	
	// Run curl asynchronously and pass of control to another function.
	toggleLoadingIcon(true);
	var executeCmd = widget.system(cmd, finishedCurling);
}

// Toggle the loading icon.
function toggleLoadingIcon(show)
{
	var icon = document.getElementById("loading");
	if(show)
	{
		icon.style.display = "block";
	}
	else
	{
		icon.style.display = "none";
	}
}

/*
	Added code stops here.
*/

function load()
{
	setupParts();
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	
	// Added code starts here.
	
	widget.setPreferenceForKey(null, createInstancePreferenceKey(widget.identifier + "-gamertag"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey(widget.identifier + "-lastChecked"));
	
	// Added code stops here.
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	
	// Added code starts here.
	
	// Turn off the loading icon if it's mistakenly on.
	toggleLoadingIcon(false);
	
	var currentTime = new Date();
	var lastChecked = widget.preferenceForKey(widget.identifier + "-lastChecked");
	
	// Guarantee a refresh if score hasn't been checked before.
	if (lastChecked == undefined)
	{
		lastChecked = 0;
	}
		
	// Don't update if the score was checked recently (5 minutes).
	if ((currentTime.getTime() - lastChecked) / (1000 * 60) > 5)
	{
		refreshData();
		
		// Set a preference for the time the widget was just updated.
		widget.setPreferenceForKey(currentTime.getTime(), widget.identifier + "-lastChecked")
	}
	
	// Added code stops here.
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// Added code starts here.

	// Turn off the loading icon if it's mistakenly on.
	toggleLoadingIcon(false);
	
	// Get the old gamertag and compare it to the new one.
	var oldGamertag = widget.preferenceForKey(widget.identifier + "-gamertag");
	var newGamertag = document.getElementById("gamertagTextfield").value;
	if (newGamertag != oldGamertag)
	{
		// Save the gamertag.
		widget.setPreferenceForKey(newGamertag, widget.identifier + "-gamertag");
		
		// Refresh the score to reflect the new tag.
		refreshData();
	}
	
	// Added code stops here.

	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}
